
/**
 * Describe class Ibis here or lose documentation points!
 * 
 * @author Jim Teresco
 * 
 * Don't forget to add your own name up here, too.
 */

import objectdraw.*;
import java.awt.*;
import java.util.Random;

public class Ibis {

    // some dimensions and sizes
    private static final double HEAD_SIZE = 30;
    private static final double STANCE_WIDTH = HEAD_SIZE/5;
    private static final double FOOT_LENGTH = HEAD_SIZE/5;
    private static final double START_HEIGHT = HEAD_SIZE;
    private static final double BEAK_OFFSET = HEAD_SIZE/5;
    private static final double BEAK_RADIUS = 2*HEAD_SIZE/5;
    private static final double BEAK_ANGLE = 50;
    private static final double EYE_SIZE = HEAD_SIZE/3;
    private static final double PUPIL_SIZE = EYE_SIZE/3;
    private static final double MAX_HEIGHT = 200;
    private static final double GROW_BY = 2;

    // the ibis parts
    private Line leftFoot, rightFoot, leftLeg, rightLeg;
    private FilledOval head;
    private FilledArc beak;
    private FilledOval leftEye, rightEye, leftPupil, rightPupil;

    // other state information
    private double xBase, yBase;
    private double height;
    
    // construct a new ibis
    public Ibis(Location betweenFeet, DrawingCanvas c) {

        // set up some state information
        xBase = betweenFeet.getX();
        yBase = betweenFeet.getY();
        height = 1;

        // construct the parts
        leftLeg = new Line(xBase - STANCE_WIDTH/2, yBase - height, xBase - STANCE_WIDTH/2, yBase, c);
        rightLeg = new Line(xBase + STANCE_WIDTH/2, yBase - height, xBase + STANCE_WIDTH/2, yBase, c);
        leftFoot = new Line(xBase - STANCE_WIDTH/2 - FOOT_LENGTH, yBase, xBase - STANCE_WIDTH/2, yBase, c);
        rightFoot = new Line(xBase + STANCE_WIDTH/2 + FOOT_LENGTH, yBase, xBase + STANCE_WIDTH/2, yBase, c);

        head = new FilledOval(xBase - HEAD_SIZE/2, yBase - HEAD_SIZE - height, HEAD_SIZE, HEAD_SIZE, c);
        head.setColor(Color.red);

        beak = new FilledArc(xBase - BEAK_RADIUS, yBase - BEAK_RADIUS - BEAK_OFFSET - height, 2*BEAK_RADIUS, 2*BEAK_RADIUS, 90 - BEAK_ANGLE/2, BEAK_ANGLE, c);
        beak.setColor(Color.yellow);
 
        leftEye = new FilledOval(xBase - EYE_SIZE, yBase - BEAK_RADIUS - BEAK_OFFSET - height - EYE_SIZE, EYE_SIZE, EYE_SIZE, c);
        leftEye.setColor(Color.white);

        leftPupil = new FilledOval(xBase - EYE_SIZE + PUPIL_SIZE, yBase - BEAK_RADIUS - BEAK_OFFSET - height - EYE_SIZE + PUPIL_SIZE, PUPIL_SIZE, PUPIL_SIZE, c);

        rightEye = new FilledOval(xBase, yBase - BEAK_RADIUS - BEAK_OFFSET - height - EYE_SIZE, EYE_SIZE, EYE_SIZE, c);
        rightEye.setColor(Color.white);

        rightPupil = new FilledOval(xBase + PUPIL_SIZE, yBase - BEAK_RADIUS - BEAK_OFFSET - height - EYE_SIZE + PUPIL_SIZE, PUPIL_SIZE, PUPIL_SIZE, c);

    }

    public void grow() {

        // remove this comment and replace with your own comments and code (of course)
    }
    
    public boolean eyesContain(Location point) {
        
        // replace the return statement below with one that answers the question correctly
        return false;
    }
    
    public void setRandomColor() {
        
        // fill in with your implementation
        
    }
}
